/*
  ==============================================================================

    This file was auto-generated!

  ==============================================================================
*/

#include "MainComponent.h"
#include <memory>

class MainComponent::SomeThread : public ThreadWithProgressWindow
{
public:
    SomeThread()
    : ThreadWithProgressWindow("Thread title", true, true)
    {}
    
    void run() override
    {
        while (progress < 1) {
            progress += 0.01;
            setProgress(progress);
            Thread::sleep(50);
        }
    }

private:
    double progress{ 0 };
};

//==============================================================================
MainComponent::MainComponent()
{
    // Set default font to Lato
    using namespace BinaryData;
    juce::LookAndFeel::getDefaultLookAndFeel().setDefaultSansSerifTypeface(Typeface::createSystemTypefaceFor(LatoRegular_ttf, LatoRegular_ttfSize));

    addAndMakeVisible(label);
    addAndMakeVisible(buttonWithTooltip);
    addAndMakeVisible(launchThread);
    addAndMakeVisible(slider);
    
    slider.textFromValueFunction = [](auto value){ return "Slider value is " + String(value, 1); };
    slider.setPopupDisplayEnabled(true, true, this);
    
    launchThread.addListener(this);

    setSize(600, 400);
}

MainComponent::~MainComponent()
{
    launchThread.removeListener(this);
}

void MainComponent::paint(Graphics& g)
{
    g.fillAll(getLookAndFeel().findColour(ResizableWindow::backgroundColourId));
}

void MainComponent::resized()
{
    auto bounds = getLocalBounds();
    const int rowHeight = getHeight() / 4.0;
    label.setBounds(bounds.removeFromTop(rowHeight));
    buttonWithTooltip.setBounds(bounds.removeFromTop(rowHeight));
    launchThread.setBounds(bounds.removeFromTop(rowHeight));
    slider.setBounds(bounds.removeFromTop(rowHeight));
}

void MainComponent::buttonClicked(Button* button)
{
    if (button == &launchThread)
        SomeThread().runThread();
}
