#pragma once

#include "../JuceLibraryCode/JuceHeader.h"

class MainComponent : public Component, private Button::Listener
{
public:
    MainComponent();
    ~MainComponent();

    void paint(Graphics&) override;
    void resized() override;

private:
    class SomeThread;
    
    const SharedResourcePointer<TooltipWindow> tooltipWindow;

    Label label{ {}, "This is a label." };
    TextButton buttonWithTooltip{ "Button With Tooltip", "This is a tooltip." };
    TextButton launchThread{ "Launch Thread" };
    Slider slider;

    void buttonClicked(Button*) override;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(MainComponent)
};
